=== contrib/xxhash/CMakeLists.txt ===
SET(XXHASHSRC xxhash.c)

if ("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang" OR "${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O3")
endif ()
ADD_LIBRARY(xxhash STATIC ${XXHASHSRC})
